<template>
  <slot />
</template>

<script setup lang="ts">
import { onMounted, ref, computed } from 'vue';

const keycloakToken = ref<string | null>(window.localStorage.getItem('KEYCLOAK_ACCESS_TOKEN'));

const isLoggedIn = ref(false);
const fullRedirectURL = computed(() => `/login?redirectUrl=${window.location.pathname}`);

const checkLoggedIn = async () => {
  if (!keycloakToken.value) {
    if (props.redirect) {
      window.location.href = fullRedirectURL.value;
    }
  } else {
    const response = await fetch('/checkuser', {
      method: 'POST',
      headers: new Headers({
        Authorization: `Bearer ${keycloakToken.value}`,
      }),
    });

    if (response.status !== 200) {
      if (props.redirect) {
        window.location.href = fullRedirectURL.value;
      }
    }
  }
  isLoggedIn.value = true;
};

onMounted(async () => {
  checkLoggedIn();
});

const props = withDefaults(
  defineProps<{
    redirect?: boolean;
  }>(),
  {
    redirect: true,
  }
);
</script>
